//
//  LCTextObject.h
//  LogoistCore
//
//  Created by Mendel Kucharzeck on 19.12.11.
//  Copyright 2011 AvisNocturna Software. All rights reserved.
//

#import "LCBaseObject.h"
#import <AvisNocturnaCrossCore/ANTextDrawingHelper.h>
#import <AvisNocturnaCrossCore/ANGeometryHelper-Defines.h>

@interface LCTextObject : LCBaseObject
{
    CGPoint position;
    float rotation;
    
    float xStretch;
    float yStretch;
    
    float lineHeightMultiple;
    float kerning;
    
    ANGeometry_PathMode pathMode;
    float strokeLineWidth;
    
    TextDrawingHelperAlignment textAlignment;
    
    NSString *text;
    ANPlatformFont *font;
    
    //Events
    CGPoint dragStartPoint;
    CGPoint dragStartPosition;
    
    //Cache
    CGPathRef cachedPathRef;
}

@property (assign) CGPoint position;
@property (assign) float rotation;

@property (assign) float xStretch;
@property (assign) float yStretch;

@property (assign) float lineHeightMultiple;
@property (assign) float kerning;

@property (assign) ANGeometry_PathMode pathMode;
@property (assign) float strokeLineWidth;

@property (retain) NSString *text;
@property (retain) ANPlatformFont *font;
@property (assign) float fontSize;

@property (assign) TextDrawingHelperAlignment textAlignment;

@end
